diff --git a/src/pbs.cpp b/src/pbs.cpp
new file mode 100644
index 0000000..ccfbbfd
--- /dev/null
+++ b/src/pbs.cpp
@@ -0,0 +1,329 @@
+/* $Id$ */
+
+/** @file pbs.cpp */
+#include "stdafx.h"
+#include "openttd.h"
+#include "pbs.h"
+#include "rail_map.h"
+#include "road_map.h"
+#include "station_map.h"
+#include "tunnelbridge_map.h"
+#include "functions.h"
+#include "debug.h"
+#include "direction_func.h"
+#include "settings_type.h"
+#include "road_func.h"
+#include "vehicle_base.h"
+#include "yapf/follow_track.hpp"
+
+/**
+ * Get the reserved trackbits for any tile, regardless of type.
+ * @param t the tile
+ * @return the reserved trackbits. TRACK_BIT_NONE on nothing reserved or
+ *     a tile without rail.
+ */
+TrackBits GetReservedTrackbits(TileIndex t)
+{
+	switch (GetTileType(t)) {
+		case MP_RAILWAY:
+			if (IsRailWaypoint(t) || IsRailDepot(t)) return GetRailWaypointReservation(t);
+			if (IsPlainRailTile(t)) return GetTrackReservation(t);
+			break;
+
+		case MP_ROAD:
+			if (IsLevelCrossing(t)) return GetRailCrossingReservation(t);
+			break;
+
+		case MP_STATION:
+			if (IsRailwayStation(t)) return GetRailStationReservation(t);
+			break;
+
+		case MP_TUNNELBRIDGE:
+			if (GetTunnelBridgeTransportType(t) == TRANSPORT_RAIL) return GetRailTunnelBridgeReservation(t);
+			break;
+
+		default:
+			break;
+	}
+	return TRACK_BIT_NONE;
+}
+
+/**
+ * Set the reservation for a complete station platform.
+ * @pre IsRailwayStationTile(start)
+ * @param start starting tile of the platform
+ * @param dir the direction in which to follow the platform
+ * @param b the state the reservation should be set to
+ */
+void SetRailwayStationPlatformReservation(TileIndex start, DiagDirection dir, bool b)
+{
+	TileIndex     tile = start;
+	TileIndexDiff diff = TileOffsByDiagDir(dir);
+
+	assert(IsRailwayStationTile(start));
+	assert(GetRailStationAxis(start) == DiagDirToAxis(dir));
+
+	do {
+		SetRailwayStationReservation(tile, b);
+		MarkTileDirtyByTile(tile);
+		tile = TILE_ADD(tile, diff);
+	} while (IsCompatibleTrainStationTile(tile, start));
+}
+
+/**
+ * Try to reserve a specific track on a tile
+ * @param tile the tile
+ * @param t the track
+ * @return true if reservation was successfull, i.e. the track was
+ *     free and didn't cross any other reserved tracks.
+ */
+bool TryReserveRailTrack(TileIndex tile, Track t)
+{
+	assert((GetTileTrackStatus(tile, TRANSPORT_RAIL, 0) & TrackToTrackBits(t)) != 0);
+
+	if (_settings_client.gui.show_track_reservation) {
+		MarkTileDirtyByTile(tile);
+	}
+
+	switch (GetTileType(tile)) {
+		case MP_RAILWAY:
+			if (IsPlainRailTile(tile)) return TryReserveTrack(tile, t);
+			if (IsRailWaypoint(tile) || IsRailDepot(tile)) {
+				if (!GetWaypointReservation(tile)) {
+					SetWaypointReservation(tile, true);
+					MarkTileDirtyByTile(tile);
+					return true;
+				}
+			}
+			break;
+
+		case MP_ROAD:
+			if (IsLevelCrossing(tile) && !GetCrossingReservation(tile)) {
+				SetCrossingReservation(tile, true);
+				BarCrossing(tile);
+				MarkTileDirtyByTile(tile);
+				return true;
+			}
+			break;
+
+		case MP_STATION:
+			if (IsRailwayStation(tile) && !GetRailwayStationReservation(tile)) {
+				SetRailwayStationReservation(tile, true);
+				MarkTileDirtyByTile(tile);
+				return true;
+			}
+			break;
+
+		case MP_TUNNELBRIDGE:
+			if (GetTunnelBridgeTransportType(tile) == TRANSPORT_RAIL && !GetRailTunnelBridgeReservation(tile)) {
+				SetTunnelBridgeReservation(tile, true);
+				return true;
+			}
+			break;
+
+		default:
+			break;
+	}
+	return false;
+}
+
+/**
+ * Lift the reservation of a specific track on a tile
+ * @param tile the tile
+ * @param t the track
+ */
+ void UnreserveRailTrack(TileIndex tile, Track t)
+{
+	assert((GetTileTrackStatus(tile, TRANSPORT_RAIL, 0) & TrackToTrackBits(t)) != 0);
+
+	if (_settings_client.gui.show_track_reservation) {
+		MarkTileDirtyByTile(tile);
+	}
+
+	switch (GetTileType(tile)) {
+		case MP_RAILWAY:
+			if (IsRailWaypoint(tile) || IsRailDepot(tile)) {
+				SetWaypointReservation(tile, false);
+				MarkTileDirtyByTile(tile);
+			}
+			if (IsPlainRailTile(tile)) UnreserveTrack(tile, t);
+			break;
+
+		case MP_ROAD:
+			if (IsLevelCrossing(tile)) {
+				SetCrossingReservation(tile, false);
+				UpdateLevelCrossing(tile);
+			}
+			break;
+
+		case MP_STATION:
+			if (IsRailwayStation(tile)) {
+				SetRailwayStationReservation(tile, false);
+				MarkTileDirtyByTile(tile);
+			}
+			break;
+
+		case MP_TUNNELBRIDGE:
+			if (GetTunnelBridgeTransportType(tile) == TRANSPORT_RAIL) SetTunnelBridgeReservation(tile, false);
+			break;
+
+		default:
+			break;
+	}
+}
+
+
+/**
+ *
+ *
+ */
+static PBSTileInfo FollowReservation(const Vehicle *v, RailTypes rts, TileIndex tile, Trackdir trackdir)
+{
+	/* Do not disallow 90 deg turns as the setting might have changed between reserving and now. */
+	CFollowTrackRail ft(v, rts);
+	while (ft.Follow(tile, trackdir)) {
+		TrackdirBits reserved = (TrackdirBits)(ft.m_new_td_bits & (GetReservedTrackbits(ft.m_new_tile) * 0x101));
+
+		/* No reservation --> path end found */
+		if (reserved == TRACKDIR_BIT_NONE) break;
+
+		/* Can't have more than one reserved trackdir */
+		Trackdir new_trackdir = FindFirstTrackdir(reserved);
+
+		/* One-way signal against us. The reservation can't be ours as it is not
+		 * a safe position from our direction and we can never pass the signal. */
+		if (HasOnewaySignalBlockingTrackdir(ft.m_new_tile, new_trackdir)) break;
+
+		tile = ft.m_new_tile;
+		trackdir = new_trackdir;
+
+		/* Depot tile? Can't continue. */
+		if (IsRailDepotTile(tile)) break;
+		/* Non-pbs signal? Reservation can't continue. */
+		if (IsTileType(tile, MP_RAILWAY) && HasSignalOnTrackdir(tile, trackdir) && !IsPbsSignal(GetSignalType(tile, TrackdirToTrack(trackdir)))) break;
+	}
+
+	return PBSTileInfo(tile, trackdir, false);
+}
+
+/**
+ * Follow a train reservation to the last tile.
+ *
+ * @param v the vehicle
+ * @returns The last tile of the reservation or the current train tile if no reservation present.
+ */
+PBSTileInfo FollowTrainReservation(const Vehicle *v)
+{
+	assert(v->type == VEH_TRAIN);
+
+	TileIndex tile = v->tile;
+	Trackdir  trackdir = GetVehicleTrackdir(v);
+
+	if (IsRailDepotTile(tile) && !GetRailDepotReservation(tile)) return PBSTileInfo(tile, trackdir, false);
+
+	PBSTileInfo res = FollowReservation(v, GetRailTypeInfo(v->u.rail.railtype)->compatible_railtypes, tile, trackdir);
+	res.okay = IsSafeWaitingPosition(v, res.tile, res.trackdir, true, _settings_game.pf.forbid_90_deg);
+	return res;
+}
+
+/**
+ *
+ *
+ *
+ */
+Vehicle *GetTrainForReservation(TileIndex tile, Track track)
+{
+	Trackdir  trackdir = TrackToTrackdir(track);
+
+	/* Create a fake train. */
+	InvalidVehicle fake_veh;
+	fake_veh.owner = GetTileOwner(tile);
+
+	RailTypes rts = GetRailTypeInfo(GetTileRailType(tile))->compatible_railtypes;
+
+	/* */
+	for (int i = 0; i < 2; ++i, trackdir = ReverseTrackdir(trackdir)) {
+		PBSTileInfo dest = FollowReservation(&fake_veh, rts, tile, trackdir);
+
+//		Vehicle *v = VehicleFromPos();
+//		if (v != NULL) {
+
+//		}
+	}
+
+	return NULL;
+}
+
+/**
+ * Determine whether a certain track on a tile is a safe position to end a path.
+ *
+ * @param v the vehicle to test for
+ * @param tile The tile
+ * @param trackdir The trackdir to test
+ * @param include_line_end Should end-of-line tiles be considered safe?
+ * @param forbid_90def Don't allow trains to make 90 degree turns
+ * @return True if it is a safe position
+ */
+bool IsSafeWaitingPosition(const Vehicle *v, TileIndex tile, Trackdir trackdir, bool include_line_end, bool forbid_90deg)
+{
+	if (IsRailDepotTile(tile)) return true;
+
+	if (IsTileType(tile, MP_RAILWAY)) {
+		/* For non-pbs signals, stop on the signal tile. */
+		if (HasSignalOnTrackdir(tile, trackdir) && !IsPbsSignal(GetSignalType(tile, TrackdirToTrack(trackdir)))) return true;
+	}
+
+	/* Check next tile. For perfomance reasons, we check for 90 degree turns ourself. */
+	CFollowTrackRail ft(v, GetRailTypeInfo(v->u.rail.railtype)->compatible_railtypes);
+
+	/* End of track? */
+	if (!ft.Follow(tile, trackdir)) {
+		/* Last tile of a terminus station is a safe position. */
+		if (include_line_end) return true;
+	}
+
+	/* Check for reachable tracks. */
+	ft.m_new_td_bits &= DiagdirReachesTrackdirs(ft.m_exitdir);
+	if (ft.m_new_td_bits == TRACKDIR_BIT_NONE) return include_line_end;
+	if (forbid_90deg) ft.m_new_td_bits &= ~TrackdirCrossesTrackdirs(trackdir);
+
+	if (ft.m_new_td_bits != TRACKDIR_BIT_NONE && KillFirstBit(ft.m_new_td_bits) == TRACKDIR_BIT_NONE) {
+		/* PBS signal on next trackdir? Safe position. */
+		if (HasPbsSignalOnTrackdir(ft.m_new_tile, FindFirstTrackdir(ft.m_new_td_bits))) return true;
+	}
+
+	return false;
+}
+
+/**
+ * Check if a safe position is free.
+ *
+ * @param v the vehicle to test for
+ * @param tile The tile
+ * @param trackdir The trackdir to test
+ * @param forbid_90def Don't allow trains to make 90 degree turns
+ * @return True if the position is free
+ */
+bool IsWaitingPositionFree(const Vehicle *v, TileIndex tile, Trackdir trackdir, bool forbid_90deg)
+{
+	Track     track = TrackdirToTrack(trackdir);
+	TrackBits reserved = GetReservedTrackbits(tile);
+
+	/* Tile reserved? Can never be a free waiting position. */
+	if (TrackOverlapsTracks(reserved, track)) return false;
+
+	/* Not reserved and depot or not a pbs signal -> free. */
+	if (IsRailDepotTile(tile)) return true;
+	if (IsTileType(tile, MP_RAILWAY) && HasSignalOnTrackdir(tile, trackdir) && !IsPbsSignal(GetSignalType(tile, track))) return true;
+
+	/* Check the next tile, if it's a PBS signal, it has to be free as well. */
+	CFollowTrackRail ft(v, GetRailTypeInfo(v->u.rail.railtype)->compatible_railtypes);
+
+	if (!ft.Follow(tile, trackdir)) return true;
+
+	/* Check for reachable tracks. */
+	ft.m_new_td_bits &= DiagdirReachesTrackdirs(ft.m_exitdir);
+	if (forbid_90deg) ft.m_new_td_bits &= ~TrackdirCrossesTrackdirs(trackdir);
+
+	return !HasReservedTracks(ft.m_new_tile, TrackdirBitsToTrackBits(ft.m_new_td_bits));
+}
diff --git a/src/pbs.h b/src/pbs.h
new file mode 100644
index 0000000..8a6a553
--- /dev/null
+++ b/src/pbs.h
@@ -0,0 +1,48 @@
+/* $Id$ */
+
+/** @file pbs.h PBS support routines */
+
+#ifndef PBS_H
+#define PBS_H
+
+#include "tile_type.h"
+#include "direction_type.h"
+#include "track_type.h"
+#include "vehicle_type.h"
+
+TrackBits GetReservedTrackbits(TileIndex t);
+
+void SetRailwayStationPlatformReservation(TileIndex start, DiagDirection dir, bool b);
+
+bool TryReserveRailTrack(TileIndex tile, Track t);
+void UnreserveRailTrack(TileIndex tile, Track t);
+
+/** This struct contains information about the end of a reserved path. */
+struct PBSTileInfo {
+	TileIndex tile;      ///< Tile the path ends, INVALID_TILE if no valid path was found.
+	Trackdir  trackdir;  ///< The reserved trackdir on the tile.
+	bool      okay;      ///< True if tile is a safe wairing position, false otherwise.
+
+	PBSTileInfo() : tile(INVALID_TILE), trackdir(INVALID_TRACKDIR), okay(false) {}
+	PBSTileInfo(TileIndex _t, Trackdir _td, bool _okay) : tile(_t), trackdir(_td), okay(_okay) {}
+};
+
+PBSTileInfo FollowTrainReservation(const Vehicle *v);
+bool IsSafeWaitingPosition(const Vehicle *v, TileIndex tile, Trackdir trackdir, bool include_line_end, bool forbid_90deg = false);
+bool IsWaitingPositionFree(const Vehicle *v, TileIndex tile, Trackdir trackdir, bool forbid_90deg = false);
+
+Vehicle *GetTrainForReservation(TileIndex tile, Track track);
+
+/**
+ * Check whether some of tracks is reserved on a tile.
+ *
+ * @param tile the tile
+ * @param tracks the tracks to test
+ * @return true if at least on of tracks is reserved
+ */
+static inline bool HasReservedTracks(TileIndex tile, TrackBits tracks)
+{
+	return (GetReservedTrackbits(tile) & tracks) != TRACK_BIT_NONE;
+}
+
+#endif /* PBS_H */
diff --git a/src/players.cpp b/src/players.cpp
index a024cd4..6633860 100644
--- a/src/players.cpp
+++ b/src/players.cpp
@@ -1270,11 +1270,8 @@ static void Load_PLYR()
 		_player_colors[index] = p->player_color;
 
 		/* This is needed so an AI is attached to a loaded AI */
-		if (p->is_ai && (!_networking || _network_server) && _ai.enabled) {
-			/* Clear the memory of the new AI, otherwise we might be doing wrong things. */
-			memset(&_players_ainew[index], 0, sizeof(PlayerAiNew));
+		if (p->is_ai && (!_networking || _network_server) && _ai.enabled)
 			AI_StartNewAI(p->index);
-		}
 	}
 }
 
diff --git a/src/rail_cmd.cpp b/src/rail_cmd.cpp
index 7325c8c..7ff8ac3 100644
--- a/src/rail_cmd.cpp
+++ b/src/rail_cmd.cpp
@@ -46,6 +46,7 @@
 #include "functions.h"
 #include "elrail_func.h"
 #include "oldpool_func.h"
+#include "pbs.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -439,7 +440,7 @@ CommandCost CmdBuildSingleRail(TileIndex tile, uint32 flags, uint32 p1, uint32 p
 /** Remove a single piece of track
  * @param tile tile to remove track from
  * @param flags operation to perform
- * @param p1 unused
+ * @param p1 force remove even if track is reserved
  * @param p2 rail orientation
  */
 CommandCost CmdRemoveSingleRail(TileIndex tile, uint32 flags, uint32 p1, uint32 p2)
@@ -452,6 +453,8 @@ CommandCost CmdRemoveSingleRail(TileIndex tile, uint32 flags, uint32 p1, uint32
 	if (!ValParamTrackOrientation((Track)p2)) return CMD_ERROR;
 	trackbit = TrackToTrackBits(track);
 
+	if (p1 == 0 && HasReservedTracks(tile, trackbit)) return_cmd_error(STR_TRAIN_IS_APPROACHING);
+
 	/* Need to read tile owner now because it may change when the rail is removed
 	 * Also, in case of floods, _current_player != owner
 	 * There may be invalid tiletype even in exec run (when removing long track),
@@ -674,7 +677,7 @@ static CommandCost CmdRailTrackHelper(TileIndex tile, uint32 flags, uint32 p1, u
 	if (flags & DC_EXEC) SndPlayTileFx(SND_20_SPLAT_2, tile);
 
 	for (;;) {
-		ret = DoCommand(tile, railtype, TrackdirToTrack(trackdir), flags, (mode == 0) ? CMD_BUILD_SINGLE_RAIL : CMD_REMOVE_SINGLE_RAIL);
+		ret = DoCommand(tile, (mode == 0) ? railtype : 0, TrackdirToTrack(trackdir), flags, (mode == 0) ? CMD_BUILD_SINGLE_RAIL : CMD_REMOVE_SINGLE_RAIL);
 
 		if (CmdFailed(ret)) {
 			if ((_error_message != STR_1007_ALREADY_BUILT) && (mode == 0)) break;
@@ -793,8 +796,10 @@ CommandCost CmdBuildTrainDepot(TileIndex tile, uint32 flags, uint32 p1, uint32 p
  * - p1 = (bit 0-2) - track-orientation, valid values: 0-5 (Track enum)
  * - p1 = (bit 3)   - 1 = override signal/semaphore, or pre/exit/combo signal or (for bit 7) toggle variant (CTRL-toggle)
  * - p1 = (bit 4)   - 0 = signals, 1 = semaphores
- * - p1 = (bit 5-6) - type of the signal, for valid values see enum SignalType in rail_map.h
- * - p1 = (bit 7)   - convert the present signal type and variant
+ * - p1 = (bit 5-7) - type of the signal, for valid values see enum SignalType in rail_map.h
+ * - p1 = (bit 8)   - convert the present signal type and variant
+ * - p1 = (bit 9-11)- start cycle from this signal type
+ * - p1 = (bit 12-14)-wrap around after this signal type
  * @param p2 used for CmdBuildManySignals() to copy direction of first signal
  * TODO: p2 should be replaced by two bits for "along" and "against" the track.
  */
@@ -803,10 +808,14 @@ CommandCost CmdBuildSingleSignal(TileIndex tile, uint32 flags, uint32 p1, uint32
 	Track track = (Track)GB(p1, 0, 3);
 	bool ctrl_pressed = HasBit(p1, 3); // was the CTRL button pressed
 	SignalVariant sigvar = (ctrl_pressed ^ HasBit(p1, 4)) ? SIG_SEMAPHORE : SIG_ELECTRIC; // the signal variant of the new signal
-	SignalType sigtype = (SignalType)GB(p1, 5, 2); // the signal type of the new signal
-	bool convert_signal = HasBit(p1, 7); // convert button pressed
+	SignalType sigtype = (SignalType)GB(p1, 5, 3); // the signal type of the new signal
+	bool convert_signal = HasBit(p1, 8); // convert button pressed
+	SignalType cycle_start = (SignalType)GB(p1, 9, 3);
+	SignalType cycle_stop = (SignalType)GB(p1, 12, 3);
 	CommandCost cost;
 
+	if (sigtype > SIGTYPE_LAST) return CMD_ERROR;
+
 	if (!ValParamTrackOrientation(track) || !IsTileType(tile, MP_RAILWAY) || !EnsureNoTrainOnTrack(tile, track))
 		return CMD_ERROR;
 
@@ -868,7 +877,7 @@ CommandCost CmdBuildSingleSignal(TileIndex tile, uint32 flags, uint32 p1, uint32
 		if (p2 == 0) {
 			if (!HasSignalOnTrack(tile, track)) {
 				/* build new signals */
-				SetPresentSignals(tile, GetPresentSignals(tile) | SignalOnTrack(track));
+				SetPresentSignals(tile, GetPresentSignals(tile) | (IsPbsSignal(sigtype) ? KillFirstBit(SignalOnTrack(track)) : SignalOnTrack(track)));
 				SetSignalType(tile, track, sigtype);
 				SetSignalVariant(tile, track, sigvar);
 			} else {
@@ -882,13 +891,21 @@ CommandCost CmdBuildSingleSignal(TileIndex tile, uint32 flags, uint32 p1, uint32
 						/* convert the present signal to the chosen type and variant */
 						SetSignalType(tile, track, sigtype);
 						SetSignalVariant(tile, track, sigvar);
+						if (IsPbsSignal(sigtype) && (GetPresentSignals(tile) & SignalOnTrack(track)) == SignalOnTrack(track)) {
+							SetPresentSignals(tile, (GetPresentSignals(tile) & ~SignalOnTrack(track)) | KillFirstBit(SignalOnTrack(track)));
+						}
 					}
 
 				} else if (ctrl_pressed) {
-					/* cycle between normal -> pre -> exit -> combo -> ... */
-					sigtype = GetSignalType(tile, track);
+					/* cycle between cycle_start and cycle_end */
+					sigtype = (SignalType)(GetSignalType(tile, track) + 1);
+
+					if (sigtype < cycle_start || sigtype > cycle_stop) sigtype = cycle_start;
 
-					SetSignalType(tile, track, sigtype == SIGTYPE_COMBO ? SIGTYPE_NORMAL : (SignalType)(sigtype + 1));
+					SetSignalType(tile, track, sigtype);
+					if (IsPbsSignal(sigtype) && (GetPresentSignals(tile) & SignalOnTrack(track)) == SignalOnTrack(track)) {
+						SetPresentSignals(tile, (GetPresentSignals(tile) & ~SignalOnTrack(track)) | KillFirstBit(SignalOnTrack(track)));
+					}
 				} else {
 					/* cycle the signal side: both -> left -> right -> both -> ... */
 					CycleSignalSide(tile, track);
@@ -899,8 +916,13 @@ CommandCost CmdBuildSingleSignal(TileIndex tile, uint32 flags, uint32 p1, uint32
 			 * direction of the first signal given as parameter by CmdBuildManySignals */
 			SetPresentSignals(tile, (GetPresentSignals(tile) & ~SignalOnTrack(track)) | (p2 & SignalOnTrack(track)));
 			SetSignalVariant(tile, track, sigvar);
+			SetSignalType(tile, track, sigtype);
 		}
 
+		if (IsPbsSignal(sigtype)) {
+			uint mask = GetPresentSignals(tile) & SignalOnTrack(track);
+			SetSignalStates(tile, (GetSignalStates(tile) & ~mask) | ((HasBit(GetTrackReservation(tile), track) ? (uint)-1 : 0) & mask));
+		}
 		MarkTileDirtyByTile(tile);
 		AddTrackToSignalBuffer(tile, track, _current_player);
 		YapfNotifyTrackLayoutChange(tile, track);
@@ -974,6 +996,7 @@ static bool CheckSignalAutoFill(TileIndex &tile, Trackdir &trackdir, int &signal
  * - p2 = (bit  4)    - 0 = signals, 1 = semaphores
  * - p2 = (bit  5)    - 0 = build, 1 = remove signals
  * - p2 = (bit  6)    - 0 = selected stretch, 1 = auto fill
+ * - p2 = (bit  7- 9) - default signal type
  * - p2 = (bit 24-31) - user defined signals_density
  */
 static CommandCost CmdSignalTrackHelper(TileIndex tile, uint32 flags, uint32 p1, uint32 p2)
@@ -1011,6 +1034,9 @@ static CommandCost CmdSignalTrackHelper(TileIndex tile, uint32 flags, uint32 p1,
 	/* Autofill must start on a valid track to be able to avoid loops */
 	if (autofill && !HasTrack(tile, track)) return CMD_ERROR;
 
+	SignalType sigtype = (SignalType)GB(p2, 7, 3);
+	if (sigtype > SIGTYPE_LAST) return CMD_ERROR;
+
 	/* copy the signal-style of the first rail-piece if existing */
 	if (HasSignals(tile)) {
 		signals = GetPresentSignals(tile) & SignalOnTrack(track);
@@ -1018,8 +1044,10 @@ static CommandCost CmdSignalTrackHelper(TileIndex tile, uint32 flags, uint32 p1,
 
 		/* copy signal/semaphores style (independent of CTRL) */
 		semaphores = GetSignalVariant(tile, track) != SIG_ELECTRIC;
+
+		sigtype = GetSignalType(tile, track);
 	} else { // no signals exist, drag a two-way signal stretch
-		signals = SignalOnTrack(track);
+		signals = IsPbsSignal(sigtype) ? SignalAlongTrackdir(trackdir) : SignalOnTrack(track);
 	}
 
 	byte signal_dir = 0;
@@ -1041,6 +1069,7 @@ static CommandCost CmdSignalTrackHelper(TileIndex tile, uint32 flags, uint32 p1,
 			uint32 p1 = GB(TrackdirToTrack(trackdir), 0, 3);
 			SB(p1, 3, 1, mode);
 			SB(p1, 4, 1, semaphores);
+			SB(p1, 5, 3, sigtype);
 
 			/* Pick the correct orientation for the track direction */
 			signals = 0;
@@ -1090,6 +1119,7 @@ static CommandCost CmdSignalTrackHelper(TileIndex tile, uint32 flags, uint32 p1,
  * - p2 = (bit  4)    - 0 = signals, 1 = semaphores
  * - p2 = (bit  5)    - 0 = build, 1 = remove signals
  * - p2 = (bit  6)    - 0 = selected stretch, 1 = auto fill
+ * - p2 = (bit  7- 9) - default signal type
  * - p2 = (bit 24-31) - user defined signals_density
  * @see CmdSignalTrackHelper
  */
@@ -1152,6 +1182,7 @@ CommandCost CmdRemoveSingleSignal(TileIndex tile, uint32 flags, uint32 p1, uint3
  * - p2 = (bit  4)    - 0 = signals, 1 = semaphores
  * - p2 = (bit  5)    - 0 = build, 1 = remove signals
  * - p2 = (bit  6)    - 0 = selected stretch, 1 = auto fill
+ * - p2 = (bit  7- 9) - default signal type
  * - p2 = (bit 24-31) - user defined signals_density
  * @see CmdSignalTrackHelper
  */
@@ -1377,7 +1408,8 @@ static CommandCost ClearTile_Track(TileIndex tile, byte flags)
 			TrackBits tracks = GetTrackBits(tile);
 			while (tracks != TRACK_BIT_NONE) {
 				Track track = RemoveFirstTrack(&tracks);
-				ret = DoCommand(tile, 0, track, flags, CMD_REMOVE_SINGLE_RAIL);
+				/* NOTE: Force removal of reserved tracks, maybe remove if no bugs found. */
+				ret = DoCommand(tile, 1, track, flags, CMD_REMOVE_SINGLE_RAIL);
 				if (CmdFailed(ret)) return CMD_ERROR;
 				cost.AddCost(ret);
 			}
@@ -1451,7 +1483,7 @@ static void DrawSingleSignal(TileIndex tile, Track track, byte condition, uint i
 		sprite = SPR_ORIGINAL_SIGNALS_BASE + image + condition;
 	} else {
 		/* All other signals are picked from add on sprites. */
-		sprite = SPR_SIGNALS_BASE + (type - 1) * 16 + variant * 64 + image + condition;
+		sprite = SPR_SIGNALS_BASE + (type - 1) * 16 + variant * 64 + image + condition + (type > SIGTYPE_LAST_NOPBS ? 64 : 0);
 	}
 
 	AddSortableSpriteToDraw(sprite, PAL_NONE, x, y, 1, 1, BB_HEIGHT_UNDER_BRIDGE, GetSaveSlopeZ(x, y, track));
@@ -1687,6 +1719,29 @@ static void DrawTrackBits(TileInfo* ti, TrackBits track)
 		if (track & TRACK_BIT_RIGHT) DrawGroundSprite(rti->base_sprites.single_e, PAL_NONE);
 	}
 
+	/* PBS debugging, draw reserved tracks darker */
+	if (_settings_client.gui.show_track_reservation) {
+		TrackBits pbs = GetTrackReservation(ti->tile);
+		if (pbs & TRACK_BIT_X) {
+			if (ti->tileh == SLOPE_FLAT || ti->tileh == SLOPE_ELEVATED) {
+				DrawGroundSprite(rti->base_sprites.single_y, PALETTE_CRASH);
+			} else {
+				DrawGroundSprite(_track_sloped_sprites[ti->tileh - 1] + rti->base_sprites.single_sloped - 20, PALETTE_CRASH);
+			}
+		}
+		if (pbs & TRACK_BIT_Y) {
+			if (ti->tileh == SLOPE_FLAT || ti->tileh == SLOPE_ELEVATED) {
+				DrawGroundSprite(rti->base_sprites.single_x, PALETTE_CRASH);
+			} else {
+				DrawGroundSprite(_track_sloped_sprites[ti->tileh - 1] + rti->base_sprites.single_sloped - 20, PALETTE_CRASH);
+			}
+		}
+		if (pbs & TRACK_BIT_UPPER) AddSortableSpriteToDraw(rti->base_sprites.single_n, PALETTE_CRASH, ti->x, ti->y, 16, 16, 0, ti->z + (ti->tileh & SLOPE_N ? 8 : 0));
+		if (pbs & TRACK_BIT_LOWER) AddSortableSpriteToDraw(rti->base_sprites.single_s, PALETTE_CRASH, ti->x, ti->y, 16, 16, 0, ti->z + (ti->tileh & SLOPE_S ? 8 : 0));
+		if (pbs & TRACK_BIT_LEFT)  AddSortableSpriteToDraw(rti->base_sprites.single_w, PALETTE_CRASH, ti->x, ti->y, 16, 16, 0, ti->z + (ti->tileh & SLOPE_W ? 8 : 0));
+		if (pbs & TRACK_BIT_RIGHT) AddSortableSpriteToDraw(rti->base_sprites.single_e, PALETTE_CRASH, ti->x, ti->y, 16, 16, 0, ti->z + (ti->tileh & SLOPE_E ? 8 : 0));
+	}
+
 	if (IsValidCorner(halftile_corner)) {
 		DrawFoundation(ti, HalftileFoundation(halftile_corner));
 
@@ -1845,6 +1900,11 @@ default_waypoint:
 
 		DrawGroundSprite(image, PAL_NONE);
 
+		/* PBS debugging, draw reserved tracks darker */
+		if (_settings_client.gui.show_track_reservation && GetWaypointReservation(ti->tile)) {
+			DrawGroundSprite(GetWaypointAxis(ti->tile) == AXIS_X ? rti->base_sprites.single_y : rti->base_sprites.single_x, PALETTE_CRASH);
+		}
+
 		if (HasCatenaryDrawn(GetRailType(ti->tile))) DrawCatenary(ti);
 
 		/* End now if buildings are invisible */
@@ -2146,12 +2206,13 @@ static TrackStatus GetTileTrackStatus_Track(TileIndex tile, TransportType mode,
 
 			b &= a;
 
-			/* When signals are not present (in neither
-			 * direction), we pretend them to be green. (So if
-			 * signals are only one way, the other way will
-			 * implicitely become `red' */
-			if ((a & 0xC) == 0) b |= 0xC;
-			if ((a & 0x3) == 0) b |= 0x3;
+			/* When signals are not present (in neither direction),
+			 * we pretend them to be green. Otherwise, it depends on
+			 * the signal type. For signals that are only active from
+			 * one side, we set the missing signals explicitely to
+			 * `green'. Otherwise, they implicitely become `red'. */
+			if (!IsOnewaySignal(tile, TRACK_UPPER) || (a & SignalOnTrack(TRACK_UPPER)) == 0) b |= ~a & SignalOnTrack(TRACK_UPPER);
+			if (!IsOnewaySignal(tile, TRACK_LOWER) || (a & SignalOnTrack(TRACK_LOWER)) == 0) b |= ~a & SignalOnTrack(TRACK_LOWER);
 
 			if ((b & 0x8) == 0) red_signals |= (TRACKDIR_BIT_LEFT_N | TRACKDIR_BIT_X_NE | TRACKDIR_BIT_Y_SE | TRACKDIR_BIT_UPPER_E);
 			if ((b & 0x4) == 0) red_signals |= (TRACKDIR_BIT_LEFT_S | TRACKDIR_BIT_X_SW | TRACKDIR_BIT_Y_NW | TRACKDIR_BIT_UPPER_W);
@@ -2196,30 +2257,54 @@ static void GetTileDesc_Track(TileIndex tile, TileDesc *td)
 			break;
 
 		case RAIL_TILE_SIGNALS: {
-			const StringID signal_type[4][4] = {
+			const StringID signal_type[6][6] = {
 				{
 					STR_RAILROAD_TRACK_WITH_NORMAL_SIGNALS,
 					STR_RAILROAD_TRACK_WITH_NORMAL_PRESIGNALS,
 					STR_RAILROAD_TRACK_WITH_NORMAL_EXITSIGNALS,
-					STR_RAILROAD_TRACK_WITH_NORMAL_COMBOSIGNALS
+					STR_RAILROAD_TRACK_WITH_NORMAL_COMBOSIGNALS,
+					STR_RAILROAD_TRACK_WITH_NORMAL_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_NORMAL_NOENTRYSIGNALS
 				},
 				{
 					STR_RAILROAD_TRACK_WITH_NORMAL_PRESIGNALS,
 					STR_RAILROAD_TRACK_WITH_PRESIGNALS,
 					STR_RAILROAD_TRACK_WITH_PRE_EXITSIGNALS,
-					STR_RAILROAD_TRACK_WITH_PRE_COMBOSIGNALS
+					STR_RAILROAD_TRACK_WITH_PRE_COMBOSIGNALS,
+					STR_RAILROAD_TRACK_WITH_PRE_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_PRE_NOENTRYSIGNALS
 				},
 				{
 					STR_RAILROAD_TRACK_WITH_NORMAL_EXITSIGNALS,
 					STR_RAILROAD_TRACK_WITH_PRE_EXITSIGNALS,
 					STR_RAILROAD_TRACK_WITH_EXITSIGNALS,
-					STR_RAILROAD_TRACK_WITH_EXIT_COMBOSIGNALS
+					STR_RAILROAD_TRACK_WITH_EXIT_COMBOSIGNALS,
+					STR_RAILROAD_TRACK_WITH_EXIT_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_EXIT_NOENTRYSIGNALS
 				},
 				{
 					STR_RAILROAD_TRACK_WITH_NORMAL_COMBOSIGNALS,
 					STR_RAILROAD_TRACK_WITH_PRE_COMBOSIGNALS,
 					STR_RAILROAD_TRACK_WITH_EXIT_COMBOSIGNALS,
-					STR_RAILROAD_TRACK_WITH_COMBOSIGNALS
+					STR_RAILROAD_TRACK_WITH_COMBOSIGNALS,
+					STR_RAILROAD_TRACK_WITH_COMBO_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_COMBO_NOENTRYSIGNALS
+				},
+				{
+					STR_RAILROAD_TRACK_WITH_NORMAL_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_PRE_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_EXIT_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_COMBO_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_PBSSIGNALS,
+					STR_RAILROAD_TRACK_WITH_PBS_NOENTRYSIGNALS
+				},
+				{
+					STR_RAILROAD_TRACK_WITH_NORMAL_NOENTRYSIGNALS,
+					STR_RAILROAD_TRACK_WITH_PRE_NOENTRYSIGNALS,
+					STR_RAILROAD_TRACK_WITH_EXIT_NOENTRYSIGNALS,
+					STR_RAILROAD_TRACK_WITH_COMBO_NOENTRYSIGNALS,
+					STR_RAILROAD_TRACK_WITH_PBS_NOENTRYSIGNALS,
+					STR_RAILROAD_TRACK_WITH_NOENTRYSIGNALS
 				}
 			};
 
